% rectangular despues de almacenamiento H por encima
H=1.5
b=4
n=0.013
ke=0.06
yn0=0.8 %probando
%
g=9.81;
%
yc=max(roots([0.5*(1+ke)+1 -H]))
Q=b*sqrt(g)*yc^1.5
Ie0=n^2*Q^2/(b*yn0)^2/(b*yn0/(2*yn0+b))^(4/3)%prbando
Iec=n^2*Q^2/(b*yc)^2/(b*yc/(2*yc+b))^(4/3)
cos(asin(Ie0))
%%
Is = 0.008
yn = 0.68991 % calculado iterando: y=sqrt(n^2*Q^2/(b*y/(2*y+b))^(4/3)/Is)/b
%%
a=0.380

Cc=0.611

y1comp=1/2/g*(Q/a/b/Cc)^2
Cv = 0.960 + 0.0979*a/y1comp
if Cv>1;Cv=1,end
y1comp_np1=1/2/g*(Q/a/b/Cc/Cv)^2*(1+Cc*a/y1comp)
while abs(y1comp-y1comp_np1)>1e-5,
  y1comp=y1comp_np1;
  Cv = 0.960 + 0.0979*a/y1comp
  if Cv>1;Cv=1,end
  y1comp_np1=1/2/g*(Q/a/b/Cc/Cv)^2*(1+Cc*a/y1comp)
end
y1comp=y1comp_np1;
y2comp=Cc*a
x2comp=a/Cc
%x2comp=2*a

parametros_definidos_aqui=0;
Is_ext=Is;
Lend = 250
Q_ext=Q;
y0=y2comp;
%yc,yn
tipodecanal=1
parametroscanal=b
%n /alfa/beta

script_calculo_remanso
yend= y_calc(end)

 L1=1050;
 x0_postcompuerta=L1+x2comp;
 figure(3)
 hold off
 plot( (x0_postcompuerta+x_calc)*cos(asin(Is)) , y_calc-Is* (x0_postcompuerta+x_calc),  (x0_postcompuerta+x_calc)*cos(asin(Is)), -Is* (x0_postcompuerta+x_calc), (x0_postcompuerta+x_calc)*cos(asin(Is)), yc-Is* (x0_postcompuerta+x_calc)*cos(asin(Is)), (x0_postcompuerta+x_calc)*cos(asin(Is)), yn-Is* (x0_postcompuerta+x_calc)*cos(asin(Is)));
 grid on;
 legend('sl','solera','yc','yn');

 if 1,
   figure(8)
   hold off
   plot( (x0_postcompuerta+x_calc)*cos(asin(Is)) , y_calc-Is* (x0_postcompuerta+x_calc),  (x0_postcompuerta+x_calc)*cos(asin(Is)), -Is* (x0_postcompuerta+x_calc), (x0_postcompuerta+x_calc)*cos(asin(Is)), yc-Is* (x0_postcompuerta+x_calc)*cos(asin(Is)), (x0_postcompuerta+x_calc)*cos(asin(Is)), yn-Is* (x0_postcompuerta+x_calc)*cos(asin(Is)));
   grid on;
 legend('sl','solera','yc','yn');
 end

%Tramo S1
Is_ext=Is;
Lend = -L1
Q_ext=Q;
y0=y1comp;
%yc,yn
tipodecanal=1
parametroscanal=b
%n /alfa/beta

script_calculo_remanso
y_calc(end)


 x0_precompuerta=L1;
 figure(3)
hold on
 plot( (x0_precompuerta+x_calc)*cos(asin(Is)) , y_calc-Is* (x0_precompuerta+x_calc),  (x0_precompuerta+x_calc)*cos(asin(Is)), -Is* (x0_precompuerta+x_calc), (x0_precompuerta+x_calc)*cos(asin(Is)), yc-Is* (x0_precompuerta+x_calc)*cos(asin(Is)), (x0_precompuerta+x_calc)*cos(asin(Is)), yn-Is* (x0_precompuerta+x_calc)*cos(asin(Is)));
 grid on;
 legend('sl','solera','yc','yn');

xS1 = (x0_precompuerta+x_calc);
yS1 = y_calc;
%tramo S2
% seccion critica en x=0 -> paso con metodo paso directo o fijo y luego script
y0=yc;
delta_y=-1e-3
y2=yc+delta_y
E2 = Q^2/(b^2*y2^2*2*g)+y2;
Ec = (Q^2/(b^2*yc^2*2*g)+yc);
Ie2=n^2*Q^2/(b*y2)^2/(b*y2/(2*y2+b))^(4/3)
Ie=(Iec+Ie2)/2
delta_x = (E2-Ec)/(Is-Ie)
x2 = 0 + delta_x

%parametros script
Is_ext=Is;
Lend = L1-x2
Q_ext=Q;
y0=y2;
%yc,yn
tipodecanal=1
parametroscanal=b
%n /alfa/beta

script_calculo_remanso

x_calc = x_calc+x2;
x_calc = [0; x_calc];
y_calc = [yc; y_calc];

figure(3)
hold on
 plot( (x_calc)*cos(asin(Is)) , y_calc-Is* (x_calc),  (x_calc)*cos(asin(Is)), -Is* (x_calc), (x_calc)*cos(asin(Is)), yc-Is* (x_calc)*cos(asin(Is)), (x_calc)*cos(asin(Is)), yn-Is* (x_calc)*cos(asin(Is)));
 grid on;
 legend('sl','solera','yc','yn');

xS2 = (x_calc);
yS2 = y_calc;


figure(4)
hold off
plot(xS1,yS1,xS2,yS2);
xlabel('x (m)'); ylabel('y (m)');
legend('Perfil S1 trazado desde compuerta','Perfil S2 desde entrada canal')
grid

figure(4)
hold off
Fr1pow2 = (Q^2./(b*yS2).^2)./(g*yS2);
plot(xS1,yS1,xS2,yS2,xS2,yS2/2.*(sqrt(1+8*Fr1pow2)-1));
xlabel('x (m)'); ylabel('y (m)');
legend('Perfil S1 trazado desde compuerta','Perfil S2 desde entrada canal','Calados conjugados al perfil S2')
grid


figure(5)
hold off
MS1 = Q^2/g/b./yS1+b/2*yS1.^2;
MS2 = Q^2/g/b./yS2+b/2*yS2.^2;
plot(xS1,MS1,xS2,MS2);legend('M(S1)','M(S2)');xlabel('x (m)'); 
grid on

Lj = 5.9*(1.199-0.790);
figure(6)
hold off
plot(xS1,yS1,xS2,yS2,xS2+Lj,yS2/2.*(sqrt(1+8*Fr1pow2)-1));
xlabel('x (m)'); ylabel('y (m)');
legend('Perfil S1 trazado desde compuerta','Perfil S2 desde entrada canal','Calados conjugados al perfil S2 trasladados Lj')
grid

if 1,
  figure(8)
hold on
min(xS1(xS1>=20.07))
 plot( xS1(xS1>=20.070)*cos(asin(Is)) , yS1(xS1>=20.070)-Is* xS1(xS1>=20.070),  xS1(xS1>=20.070)*cos(asin(Is)), -Is* xS1(xS1>=20.070), xS1(xS1>=20.070)*cos(asin(Is)), yc-Is* xS1(xS1>=20.070)*cos(asin(Is)), xS1(xS1>=20.070)*cos(asin(Is)), yn-Is* xS1(xS1>=20.070)*cos(asin(Is)));

max(xS2(xS2<=17.657))
 plot( xS2(xS2<=17.657)*cos(asin(Is)) , yS2(xS2<=17.657)-Is* xS2(xS2<=17.657),  xS2(xS2<=17.657)*cos(asin(Is)), -Is* xS2(xS2<=17.657), xS2(xS2<=17.657)*cos(asin(Is)), yc-Is* xS2(xS2<=17.657)*cos(asin(Is)), xS2(xS2<=17.657)*cos(asin(Is)), yn-Is* xS2(xS2<=17.657)*cos(asin(Is)));
end